<?php

require_once 'model/class.adventuresmodel.php' ;
require_once 'tools/class.collection.php' ;

require_once 'tools/class.type.php' ;

require_once 'model/class.kind.php' ;

class AdventuresCollection extends Collection
{
	public function __construct($something = null)
	{
		$this->_type = 'Adventure' ;
		parent::__construct($something) ;
	}

	public function push(Adventure $adv)
	{
		if(array_key_exists($adv->id, $this->collection))
		{
			trigger_error('Double id insertion catched !') ;
		}
		
		parent::push($adv, $adv->id) ;
	}
}

class Adventure extends Type
{
	protected function initFromType($thing)
	{
		$this->__set('id', $thing->id) ;
		$this->__set('title', $thing->title) ;
		$this->__set('synopsis', $thing->synopsis) ;
		$this->__set('critic', $thing->critic) ;
		$this->__set('kind', $thing->kind) ;
	}

	public function __clone()
	{
		return new self($this) ;
	}

	protected function __set($attr, $value)
	{
		if($attr == 'kind_id')
			parent::__set('kind', new Kind($value)) ;
		else
			parent::__set($attr, $value) ;
	}
	
	public function getKind() 
	{
		if(is_object($this->kind))
			return clone $this->kind ;
		else
			return null ;
	}

	protected function setKind($kind)
	{
		if(is_null($kind) or $kind instanceof Kind)
		{
			$this->kind = is_null($kind) ? null : clone $kind ;
			return true ;
		}
		else
		{
			$this->kind = null ;
			return false ;
		}
	}

	protected $id ;
	protected $title ;
	protected $synopsis ;
	protected $critic ;

	protected $kind ;
}

class AdventureMutable extends Adventure
{
	public function __construct(Adventure $adv = null)
	{
		parent::__construct($adv) ;
	}

	public function __set($attr, $value)
	{
		if(property_exists($this, $attrs))
		{
			parent::__set($attr,$value) ;
			return true ;
		}
		else
		{
			trigger_error('Bad attribute procesed !') ;
			return false ;
		}
	}
}

?>
