<?php

require_once 'model/class.adventuresmodel.php' ;
require_once 'tools/class.collection.php' ;

require_once 'tools/class.type.php' ;

require_once 'model/class.kind.php' ;

class KindsCollection extends Collection
{
	public function __construct($something = null)
	{
		$this->type = 'Kind' ;
		parent::__construct($something) ;
	}

	public function push(Kind $kind)
	{
		if(array_key_exists($kind->id, $this->collection))
		{
			trigger_error('Double id insertion catched !') ;
		}
		
		parent::push($kind, $kind->id) ;
	}
}

class Kind extends Type
{
	/* For purpose debugging
		var_dump($params) ;
	public function __construct($params = null)
	{
		parent::__construct($params) ;
		var_dump($this) ;
	}
	*/
	
	protected function initFromType($thing)
	{
		$this->__set('id', $thing->id) ;
		$this->__set('title', $thing->title) ;
		$this->__set('content', $thing->content) ;
	}

	public function __clone()
	{
		return new self ($this) ;
	}

	protected $id ;
	protected $title ;
	protected $content ;
}

class KindMutable extends Kind
{
	public function __construct(Kind $kind = null)
	{
		parent::__construct($kind) ;
	}

	public function __set($attr, $value)
	{
		return parent::__set($attr,$value) ;
	}
}

?>
