<?php

require_once 'model/class.myadventuresmodel.php' ;

// @todo refactorying with class.myadventure.php

class MyKindFinder extends MyFinder
{
	public function __construct($mycon)
	{
		parent::__construct($mycon) ;
		$this->_myclass = 'MyKind' ;
		$this->_tableName = 'Kinds' ;
		$this->_mycollectionclass = 'MyKindsCollection' ;
	}
}

class MyKindsCollection extends KindsCollection
{
	const SQL_SELECT = "select * from Kinds limit %d, %d" ;
	const SQL_SELECT_ALL = 'select * from Kinds' ;
	const SQL_COUNT = 'select count(*) from Kinds' ;

	public function __construct($something = null)
	{
		parent::__construct($something) ;
	}

	public function connect($handler)
	{
		$this->_handler = $handler ;
	}

	public function select($offset, $limit)
	{
		$sql = sprintf(self::SQL_SELECT, $offset, $limit) ;
		return $this->query($sql) and $this->fetch() ;
	}

	public function selectAll()
	{
		return $this->query(self::SQL_SELECT_ALL) and $this->fetch() ;
	}

	public function count()
	{
		$sql = sprintf(self::SQL_COUNT) ;
		$res = $this->_handler->query($sql) ;
		if($res)
		{
			$obj = $res->fetch_object() ;
			$this->count = $obj->howmany ;
		}
		else
			$this->count = 0 ;

		$res->free() ;

		return $this->count ;
	}

	public function getRaw()
	{
		return new KindsCollection($this) ;
	}

	protected function query($sql) 
	{
		$this->_result = $this->_handler->query($sql) ;
		return $this->_result instanceof mysqli_result;
	}

	protected function fetch()
	{
		if($this->_result instanceof mysqli_result 
				and ($this->_result->num_rows > 0))
		{
			while($obj = $this->_result->fetch_object())
			{
				$kind = new Kind($obj) ;
				$this->push($kind) ;
			}

			$this->_result->free() ;

			return true ;
		}
		else
			return false ;
	}

	protected function setThingCollectionFromCollection($collection)
	{
		trigger_error('Unimplemented') ;
	}

	protected $count = null ;

	protected $_handler = null ;
	protected $_result = null ;
}

class MyKind extends MyType
{
	const SQL_FIND_FIRST = "select id from %s order by %s limit 1" ;
	const SQL_SELECT_BY_ID = "select title, content from %s where id = ?" ;
	const SQL_SELECT_BY_NAME = "select id, title, content from %s where title = ?" ;
	const SQL_INSERT = "insert %s (title, content) values (?, ?)" ;
	const SQL_REPLACE = "replace %s (id, title, content) values values (?, ?, ?, ?)" ;
	const SQL_UPDATE = "update %s set title = ?, content = ?  where id = ?" ;
	const SQL_DELETE = "delete from %s where id = ?" ;

	const SQL_FIND_NAME = "select * from %s where title = ?" ;


	public function __construct($param = null)
	{
		parent::__construct() ;
		$this->_thing = new Kind($param) ;
		$this->_myTableName = 'Kinds' ;
	}

	public function getRaw()
	{
		return new Kind($this->_thing) ;
	}

	protected function getSQLTemplate($method)
	{
		switch($method)
		{
			case 'FIND_FIRST'		: return self::SQL_FIND_FIRST ;
			case 'SELECT_BY_ID'		: return self::SQL_SELECT_BY_ID ;
			case 'SELECT_BY_NAME'	: return self::SQL_SELECT_BY_NAME ;
			case 'INSERT'			: return self::SQL_INSERT ;
			case 'REPLACE'			: return self::SQL_REPLACE ;
			case 'UPDATE'			: return self::SQL_UPDATE ;
			case 'DELETE'			: return self::SQL_DELETE ;
			default					: return 'no SQL template' ;
		}
	}

	protected function setThingFromSQLStmt($stmt)
	{
		// if(!$stmt->execute())	return false ;
		$stmt->bind_result($title, $content) ;

		$stmt->execute() ;
		$stmt->store_result() ;
		$stmt->fetch() ;
		$stmt->free_result() ;
		$stmt->close() ;

		$this->_thing->title = $title ;
		$this->_thing->content = $content ;
		return true ;
	}

	protected function setSQLStmtFromThing($stmt)
	{
		$stmt->bind_param( 'ssi'
			, $this->_thing->title
			, $this->_thing->content 
			, $this->_thing->id
			) ;
		$ret = ($stmt->execute() and $stmt->num_rows) ;
		$stmt->close() ;

		return $ret ;
	}

	protected function setThingFromStdObject($obj)
	{
		trigger_error('Unimplemented') ;
	}

	protected function setThingFromArray($array)
	{
		trigger_error('Unimplemented') ;
	}

	protected function setThingFromSQLObject($obj)
	{
		$this->_thing->id = $obj->id ;
		$this->_thing->title = $obj->title ;
		$this->_thing->content = $obj->content ;
	}
}


?>
