<?php

require_once 'model/class.adventuresmodel.php' ;
require_once 'tools/class.collection.php' ;
require_once 'tools/class.type.php' ;

require_once 'model/class.adventure.php' ;
require_once 'model/class.kind.php' ;

class NewspapersCollection extends Collection
{
	public function __construct($something = null)
	{
		$this->_type = 'Newspaper' ;
		parent::__construct($something) ;
	}

	public function push(Newspaper $news)
	{
		if(array_key_exists($news->id, $this->collection))
		{
			trigger_error('Double id insertion catched !') ;
		}
		
		parent::push($news, $news->id) ;
	}
}

class Newspaper extends Type
{
	protected function initFromType($thing)
	{
		$this->__set('id', $thing->id) ;
		$this->__set('title', $thing->title) ;
		$this->__set('content', $thing->content) ;
		$this->__set('adventure', $thing->adventure) ;
		$this->__set('kind', $thing->kind) ;
	}

	public function __clone()
	{
		return new self($this) ;
	}

	protected function __set($attr, $value)
	{
		if($attr == 'kind_id')
			parent::__set('kind', new Kind($value)) ;
		elseif($attr == 'adventure_id')
			parent::__set('adventure', new Adventure($value)) ;
		else
			parent::__set($attr, $value) ;
	}
	
	public function getAdventure() 
	{
		if(is_object($this->adventure))
			return clone $this->adventure ;
		else
			return null ;
	}

	protected function setAdventure(Adventure $adventure)
	{
		$this->adventure = clone $adventure ;
		return true ;
	}

	public function getKind() 
	{
		if(is_object($this->kind))
			return clone $this->kind ;
		else
			return null ;
	}

	protected function setKind(Kind $kind)
	{
		$this->kind = clone $kind ;
		return true ;
	}

	protected $id ;
	protected $title ;
	protected $content ;

	protected $adventure ;
	protected $kind ;
}

class NewspaperMutable extends Newspaper
{
	public function __construct(Newspaper $npaper = null)
	{
		parent::__construct($npaper) ;
	}

	public function __set($attr, $value)
	{
		if(property_exists($this, $attrs))
		{
			parent::__set($attr,$value) ;
			return true ;
		}
		else
		{
			trigger_error('Bad attribute procesed !') ;
			return false ;
		}
	}
}

?>
