-- 

drop table if exists Cuts ;
drop table if exists Newspapers ;
drop table if exists Actors ;
drop table if exists Characters ;
drop table if exists Adventures ;
drop table if exists Kinds ;

create table Kinds
( id integer auto_increment primary key
, title varchar(255) not null
, content text
, creation datetime not null
, modified timestamp not null
) type = InnoDB ;

create table Adventures
( id integer auto_increment primary key
, title varchar(255) not null
, synopsis text
, critic text
, creation datetime not null
, modified timestamp not null

, kind_id integer

, foreign key (kind_id) references Kinds (id)
) type = InnoDB ;

create table Cuts
( id integer auto_increment primary key
, title varchar(255) not null
, duration time
, `release` date
, critic text
, data blob
, track decimal(3,1) unsigned zerofill
, creation datetime not null
, modified timestamp not null

, adventure_id integer

, foreign key (adventure_id) references Adventures (id)
) type = InnoDB ;

create table Newspapers
( id integer auto_increment primary key
, title varchar(255) not null
, content text
, creation datetime not null
, modified timestamp not null

, adventure_id integer
, kind_id integer

, foreign key (kind_id) references Kinds (id)
, foreign key (adventure_id) references Adventures (id)
) type = InnoDB ;

create table Actors
( id integer auto_increment primary key
, creation datetime not null
, modified timestamp not null
) type = InnoDB ;

create table Characters
( id integer auto_increment primary key
, title varchar(255) not null
, creation datetime not null
, modified timestamp not null

, adventure_id integer
, actor_id integer

, foreign key (adventure_id) references Adventures (id)
, foreign key (actor_id) references Actors (id)
) type = InnoDB ;


-- 
