<?php

class Collection implements Iterator
{
	public function __construct($something = null)
	{
		if(!is_null($something))
			$this->importCollection($something) ;
	}

	protected function importCollection($collection)
	{
		if(is_array($collection) or $collection instanceof Iterator)
			foreach($collection as $element)
				if($this->isPushable($element))
					$this->push($element) ;

		$this->isvalid = count($this->collection) > 0 ? true : false ;
	}

	protected function isPushable($thing)
	{
		if(is_null($this->type))
			return true ;
		elseif($this->type == 'integer' or $this->type == 'int')
			return is_integer($thing) ;
		elseif($this->type == 'boolean' or $this->type == 'bool')
			return is_bool($thing) ;
		elseif($this->type == 'float')
			return is_float($thing) ;
		elseif($this->type == 'string')
			return is_string($thing) ;
		elseif($this->type == 'array')
			return is_array($thing) ;
		elseif(is_object($thing)) 
			return $thing instanceof $this->type ;
		else
		{
			trigger_error("Strange non-existant type {$this->type}") ;
			return false ;
		}
	}

	public function push($thing, $id = null)
	{
		if($this->isPushable($thing))
		{
			if(is_null($id))
				$this->collection[] = $thing ;
			else
				$this->collection[$id] = $thing ;

			return $this->isvalid = true ;
		}

		return false ;
	}

	public function pop() 
	{
		// XXX : BUG with array of booleans !
		$poped = array_pop($this->collection) ;
		if($poped === false)
			$this->isvalid = false ;

		return $poped ;
	}

	public function valid()
	{
		return $this->isvalid ;
	}

	public function next()
	{
		$hasnext = next($this->collection) ;
		if($hasnext === false)
			$this->isvalid = false ;

		return $hasnext ;
	}
	public function current()
	{
		return current($this->collection) ;
	}

	public function key()
	{
		return key($this->collection) ;
	}

	public function rewind()
	{
		return reset($this->collection) ;
	}

	public function length()
	{
		return count($this->collection) ;
	}

	protected $collection = array() ;

	private $isvalid = false ;
	protected $type = null ;
}
?>
