<?php

/** This extends some methods. Goal is to clarify DOM handling
  *
  * @todo encapsulate static functions
  */
class DOMDocExt extends DOMDocument
{
	/** It extends parent method to simplify attribute assignations at
	  * element creation time. If $value or $attrs are not UTF-8
	  * strings, we encode it.
	  *
	  * @todo: UTF-8 detection to handle encoding... really ;)
	  * @todo: Handle errors from entities insertions in element name and attribute content
	  * 
	  * @param string $name Element name like a, rdf:rdf, form, etc.
	  * @param string $value Content includes in tag
	  * @param array $attrs Key is attribute name, value is content attribute
	  * @return DOMElement|null
	  */
	public function createElement($name, $value=null, $attrs=null)
	{
		if(is_null($value))
			$node = parent::createElement($name) ;
		else
			$node = @parent::createElement($name, utf8_encode($value)) ;
		
		if(!is_null($attrs))
			foreach($attrs as $attr => $attrvalue)
				@$node->setAttribute($attr, utf8_encode($attrvalue)) ;

		return $node ;
	}
}
