<?php

abstract class Type
{
	protected $_type = null ;

	public function __construct($param = null)
	{
		$this->_type = get_class($this) ;

		if(is_numeric($param))
		{
			$this->id = $param ;
		}
		elseif(is_array($param))
		{
			$this->initFromArray($param) ;
		}
		elseif(is_object($param) and $param instanceof $this->_type)
		{
			$this->initFromType($param) ;
		}
		elseif(is_object($param))
		{
			$this->initFromObject($param) ;
		}
	}

	public function __get($attr)
	{
		if(method_exists($this, "get$attr"))
			return $this->{"get$attr"}() ;
		elseif(property_exists($this, $attr))
			return $this->$attr ;
		else
			return null ;
	}

	abstract protected function initFromType($thing) ;

	protected function initFromArray($array)
	{
		foreach($array as $attr => $value)
			$this->__set($attr, $value) ;
	}

	protected function initFromObject($obj)
	{
		if(!is_null($obj))
		{
			$attrs = get_object_vars($obj) ;
			foreach($attrs as $attr => $value)
				$this->__set($attr, $obj->$attr) ;
		}
	}
	
	protected function __set($attr, $value)
	{
		if(method_exists($this, "set$attr"))
			return $this->{"set$attr"}($value) ;
		elseif(property_exists($this, $attr))
			return $this->$attr = $value ;
		else
		{
			trigger_error("No mutator for $attr attribute.") ;
			return false ;
		}
	}
}

?>
