<?php

/**
  * @todo manage size for fields
  * @todo do generics method into HTML Webget
  */

require_once 'lib/view/class.webget.php' ;
require_once 'lib/tools/class.url.php' ;

abstract class WGContentAdventureHTML extends Webget
{
	public function setAdventure($adv)
	{
		$this->adventure = $adv ;
	}

	public function setKindsList($kindList)
	{
		$this->kindList = $kindList ;
	}

	protected $adv = null ;
	protected $kindList = null ;
}

class WGContentAdventureHTMLShow extends WGContentAdventureHTML
{
	public function append()
	{
		if($this->adventure instanceof Adventure)
		{
			if($this->isEditable())
			{
				$actionsnode = $this->_canvas->createElement
					( 'div'
					, null
					, array('class' => 'actions')
					) ;
				
				foreach($this->_events['action'] as $event)
				{
					$eventNode = $this->createLinkEvent
						($event, 'adventure', $this->adventure->id) ;
					$actionsnode->appendChild($eventNode) ;
				}

				$this->_node->appendChild($actionsnode) ;
			}

			$advtitlenode = $this->_canvas->createElement
				('h1', $this->adventure->title, array('id' => "adv-{$this->adventure->id}") ) ;
			//$advtitlenode->setAttribute('id', "adv-{$adv->id}") ;

			$this->_node->appendChild($advtitlenode) ;

			$synopsisnode = $this->_canvas->createElement
				('span', "{$this->adventure->synopsis}") ;
			$criticnode = $this->_canvas->createElement
				('p', "{$this->adventure->critic}") ;

			$this->_node->appendChild($synopsisnode) ;
			$this->_node->appendChild($criticnode) ;


			/* TODO : list
			// Append previous context menu
			if($this->offset > 0)
			{
				$p_offset = $this->offset - $this->count ;
				if($prev_num < 0) $prev_num = 0 ;

				$prev = $this->_canvas->createElement('a', utf8_encode('prcdent')) ;
				$prev->setAttribute('href', "{$this->filename}?adv_offset=$p_offset") ;
				$this->_node->appendChild($prev) ;
			}

			// Append next context menu
			if($this->total > ($this->offset + $this->count))
			{
				$n_offset = $this->offset + $this->count ;

				$next = $this->_canvas->createElement('a', utf8_encode('suivant')) ;
				$next->setAttribute('href', "{$this->filename}?adv_offset=$n_offset") ;
				$this->_node->appendChild($next) ;
			}
			*/
		}
	}
}

class WGContentAdventureHTMLUpdate extends WGContentAdventureHTML
{
	public function append()
	{
		if($this->adventure instanceof Adventure)
		{
			$formNode	= $this->createFormNode() ;
			$hideNode	= $this->createActionInputNode() ;
			$idNode		= $this->createIdNode() ;
			$typeNode	= $this->createTypeNode() ;
			$kindsOptionNode = $this->createKindOptionList() ;
			
			$inputTitleNode = $this->createLabeledFormInput
				( 'Titre'
				, "form-adv_{$this->adventure->id}-title"
				, 'title'
				, "{$this->adventure->title}"
				) ;

			$inputSynopsisNode = $this->createLabeledFormTextarea
				( 'Synopsis'
				, "form-adv_{$this->adventure->id}-synopsis"
				, 'synopsis'
				, "{$this->adventure->synopsis}"
				) ;

			$inputCriticNode = $this->createLabeledFormTextarea
				( 'Critique'
				, "form-adv_{$this->adventure->id}-critic"
				, 'critic'
				, "{$this->adventure->critic}"
				) ;

			$valButton = $this->_canvas->createElement
				( 'input'
				, null
				, array('type' => 'submit') 
				) ;

			$formNode->appendChild($hideNode) ;
			$formNode->appendChild($idNode) ;
			$formNode->appendChild($typeNode) ;
			$formNode->appendChild($kindsOptionNode) ;
			$formNode->appendChild($inputTitleNode) ;
			$formNode->appendChild($inputSynopsisNode) ;
			$formNode->appendChild($inputCriticNode) ;
			$formNode->appendChild($valButton) ;

			$this->_node->appendChild($formNode) ;
		}
	}

	protected function createKindOptionList()
	{
		$selectnode = $this->createOptionList
			( 'kind'
			, $this->kindsList
			, $this->newspaper->kind) ;

		return $selectnode ;
	}
}

class WGContentAdventureHTMLAdd extends WGContentAdventureHTMLUpdate
{
	protected function createActionInputNode()
	{
		$hidenode = $this->_canvas->createElement
			( 'input'
			, null
			, array
				( 'name' => 'action'
				, 'value' => 'add'
				, 'type' => 'hidden'
				)
			) ;
		
		return $hidenode ;
	}

	protected function createIdNode()
	{
		$idnode = $this->_canvas->createElement
			( 'input'
			, null
			, array
				( 'name' => 'id'
				, 'type' => 'hidden'
				, 'value' => 'null'
				)
			) ;

		return $idnode ;
	}
}

abstract class WGContentAdventureList extends Webget
{
	public function setAdventures($advs)
	{
		$this->adventures = $advs ;
	}
	
	public function setRange($offset, $count)
	{
		$this->offset = (integer) $offset ;
		$this->count = (integer) $count ;
	}
	
	public function setTotal($total)
	{
		$this->total = (integer) $total ;
	}

	protected $title = null ;
	protected $advs = null ;
	protected $offset = null ;
	protected $count = null ;
	protected $total = null ;
}

class WGContentAdventureListHTMLShow extends WGContentAdventureList
{
	public function append()
	{
		if($this->isEditable())
		{
			$newNode = $this->createLinkEvent($this->_events['add'], 'adventure', null) ;
			$this->_node->appendChild($newNode) ;
		}

		
		// Append adventures list to the node
		if($this->adventures instanceof AdventuresCollection)
		{
			$olnode = $this->_canvas->createElement
				( 'ol'
				, null
				, array('style' => "list-style: none ;")
				) ;

			$i = $this->offset ;
			foreach($this->adventures as $adv)
			{
				$i++ ;
				$advtitlenode = $this->_canvas->createElement
					( 'li'
					, "$i. ".$adv->title
					, array('id' => "adv-{$adv->id}")
					) ;

				$viewNode = $this->createLinkEvent($this->_events['show'], 'adventure', $adv->id) ;
				$advtitlenode->appendChild($viewNode) ;

				if($this->isEditable())
				{
					$updateNode = $this->createLinkEvent($this->_events['update'], 'adventure', $adv->id) ;
					$advtitlenode->appendChild($updateNode) ;

					$deleteNode = $this->createLinkEvent($this->_events['delete'], 'adventure', $adv->id) ;
					$advtitlenode->appendChild($deleteNode) ;
				}

				$olnode->appendChild($advtitlenode) ;

				$advcriticnode = $this->_canvas->createElement
					('p', $adv->critic) ;
				$olnode->appendChild($advcriticnode) ;
			}

			$this->_node->appendChild($olnode) ;
		}

		// Append previous context menu
		/*
		if($this->offset > 0)
		{
			$p_offset = $this->offset - $this->count ;
			if($prev_num < 0) $prev_num = 0 ;

			$prev = $this->_canvas->createElement
				( 'a'
				, 'prcdent'
				, array('href' => "{$this->filename}?offset=$p_offset")
				) ;
			$this->_node->appendChild($prev) ;
		}
		*/

		// Append next context menu
		if($this->total > ($this->offset + $this->count))
		{
			$n_offset = $this->offset + $this->count ;

			$next = $this->_canvas->createElement
				( 'a'
				, 'suivant'
				, array('href' => "{$this->filename}?offset=$n_offset")
				) ;
			$this->_node->appendChild($next) ;
		}
	}
}

class WGContentAdventureListHTMLUpdate extends WGContentAdventureList
{
	public function append()
	{
		if($this->adventures instanceof AdventuresCollection)
		{
			foreach($this->adventures as $adv)
			{
				// @todo WG must have own WG chils list
				$advform = new WGContentAdventureUpdate($this->_canvas) ;
				$advform->setAdventure($adv) ;
				$advform->append() ;
			}
		}
	}
}

?>
