<?php

/**
  * @todo manage size for fields
  * @todo do generics method into HTML Webget
  */

require_once 'lib/view/class.webget.php' ;

abstract class WGContentKindHTML extends Webget
{
	public function setKind($kind)
	{
		$this->kind = $kind ;
	}

	protected $kind = null ;
}

class WGContentKindHTMLShow extends WGContentKindHTML
{
	public function append()
	{
		if($this->kind instanceof Kind)
		{
			if($this->isEditable())
			{
				$actionsnode = $this->_canvas->createElement
					( 'div'
					, null
					, array('class' => 'actions')
					) ;
				
				foreach($this->_events['action'] as $properties)
				{
					$url = $this->_scriptPathName
						."?id={$this->kind->id}"
						."&type=kind"
						."&action={$properties['value']}" ;
					$editnode = $this->_canvas->createElement
						( 'a'
						, $properties['caption']
						, array('href' => $url)
						) ;
					$actionsnode->appendChild($editnode) ;
				}

				$this->_node->appendChild($actionsnode) ;
			}

			$titlenode = $this->_canvas->createElement
				('h1', $this->kind->title, array('id' => "kind-{$this->kind->id}") ) ;

			$this->_node->appendChild($titlenode) ;

			$contentnode = $this->_canvas->createElement
				('p', "{$this->kind->content}") ;

			$this->_node->appendChild($contentnode) ;
		}
	}
}

class WGContentKindHTMLUpdate extends WGContentKindHTML
{
	public function append()
	{
		if($this->kind instanceof Kind)
		{
			$formnode = $this->_canvas->createElement
				('form'
				, null
				, array
					( 'action' => "{$this->_scriptPathName}"
					, 'method' => 'post'
					)
				) ;

			$hidenode = $this->_canvas->createElement
				( 'input'
				, null
				, array
					( 'name' => 'action'
					, 'value' => 'update'
					, 'type' => 'hidden'
					)
				) ;
			$formnode->appendChild($hidenode) ;

			$idnode = $this->_canvas->createElement
				( 'input'
				, null
				, array
					( 'name' => 'id'
					, 'type' => 'hidden'
					, 'value' => "{$this->kind->id}"
					)
				) ;
			$formnode->appendChild($idnode) ;

			$typenode = $this->_canvas->createElement
				( 'input'
				, null
				, array
					( 'name' => 'type'
					, 'type' => 'hidden'
					, 'value' => 'kind'
					)
				) ;
			$formnode->appendChild($typenode) ;

			$inputnode = $this->createLabeledFormInput
				( 'Abbrviation'
				, "form-kind_{$this->kind->id}-title"
				, 'title'
				, "{$this->kind->title}"
				) ;
			$formnode->appendChild($inputnode) ;

			$inputnode = $this->createLabeledFormInput
				( 'Titre complet'
				, "form-kind_{$this->kind->id}-content"
				, 'content'
				, "{$this->kind->content}"
				) ;
			$formnode->appendChild($inputnode) ;

			$valbutton = $this->_canvas->createElement
				( 'input'
				, null
				, array('type' => 'submit') 
				) ;
			$formnode->appendChild($valbutton) ;

			$this->_node->appendChild($formnode) ;
		}
	}

	protected function createKindOptionList()
	{
		$selectnode = $this->_canvas->createElement
			( 'select'
			, null
			, array('name' => 'kind-id')
			) ;
		foreach($this->kinds as $kind)
		{
			$attrs = array('value' => "{$kind->id}") ;
			if($this->adv->kind->id == $kind->id)
				$attrs['selected'] = 'selected' ;

			$optnode = $this->_canvas->createElement
				( 'option'
				, $kind->title
				, $attrs
				) ;

			$selectnode->appendChild($optnode) ;
		}

		return $selectnode ;
	}

	protected $kinds = null ;
}

?>
