<?php

/**
  * @todo manage size for fields
  * @todo do generics method into HTML Webget
  */

require_once 'lib/view/class.webget.php' ;

abstract class WGContentNewspaperHTML extends Webget
{
	public function setNewspaper($newspaper)
	{
		$this->newspaper = $newspaper ;
	}

	public function setAdventuresList($advs)
	{
		$this->adventuresList = $advs ;
	}

	public function setKindsList($kinds)
	{
		$this->kindsList = $kinds ;
	}

	protected $newspaper = null ;
}

class WGContentNewspaperHTMLShow extends WGContentNewspaperHTML
{
	public function append()
	{
		if($this->newspaper instanceof Newspaper)
		{
			if($this->isEditable())
			{
				$actionsNode = $this->_canvas->createElement
					( 'div'
					, null
					, array('class' => 'actions')
					) ;
				
				foreach($this->_events['action'] as $event)
				{
					$eventNode = $this->createLinkEvent($event, 'newspaper', $this->newspaper->id) ;
					$actionsNode->appendChild($eventNode) ;
				}

				$this->_node->appendChild($actionsNode) ;
			}

			$titleNode = $this->_canvas->createElement
				('h1', $this->newspaper->title, array('id' => "newspaper-{$this->newspaper->id}") ) ;
			//$advtitlenode->setAttribute('id', "adv-{$adv->id}") ;

			$this->_node->appendChild($titleNode) ;

			$contentNode = $this->_canvas->createElement
				('span', "{$this->newspaper->contentNode}") ;

			$this->_node->appendChild($contentNode) ;


			/* TODO : list
			// Append previous context menu
			if($this->offset > 0)
			{
				$p_offset = $this->offset - $this->count ;
				if($prev_num < 0) $prev_num = 0 ;

				$prev = $this->_canvas->createElement('a', utf8_encode('prcdent')) ;
				$prev->setAttribute('href', "{$this->filename}?adv_offset=$p_offset") ;
				$this->_node->appendChild($prev) ;
			}

			// Append next context menu
			if($this->total > ($this->offset + $this->count))
			{
				$n_offset = $this->offset + $this->count ;

				$next = $this->_canvas->createElement('a', utf8_encode('suivant')) ;
				$next->setAttribute('href', "{$this->filename}?adv_offset=$n_offset") ;
				$this->_node->appendChild($next) ;
			}
			*/
		}
	}
}

class WGContentNewspaperHTMLUpdate extends WGContentNewspaperHTML
{
	public function append()
	{
		if($this->newspaper instanceof Newspaper)
		{
			$formNode	= $this->createFormNode() ;
			$hideNode	= $this->createActionInputNode() ;
			$idNode		= $this->createIdNode() ;
			$typeNode	= $this->createTypeNode() ;
			$adventuresList = $this->createAdventureOptionList() ;
			$kindsOptionList = $this->createKindOptionList() ;
			$titleNode = $this->createLabeledFormInput
				( 'Titre'
				, "form-newspaper_{$this->newspaper->id}-title"
				, 'title'
				, "{$this->newspaper->title}"
				) ;
			$contentNode = $this->createLabeledFormTextarea
				( 'Contenu'
				, "form-newspaper_{$this->newspaper->id}-content"
				, 'content'
				, "{$this->newspaper->content}"
				) ;
			$valButton = $this->_canvas->createElement
				( 'input'
				, null
				, array('type' => 'submit') 
				) ;

			$formNode->appendChild($hideNode) ;
			$formNode->appendChild($idNode) ;
			$formNode->appendChild($typeNode) ;
			$formNode->appendChild($adventuresList) ;
			$formNode->appendChild($kindsOptionList) ;
			$formNode->appendChild($titleNode) ;
			$formNode->appendChild($contentNode) ;
			$formNode->appendChild($valButton) ;

			$this->_node->appendChild($formNode) ;
		}
	}

	protected function createKindOptionList()
	{
		$selectnode = $this->createOptionList
			( 'kind'
			, $this->kindsList
			, $this->newspaper->kind
			, true ) ;
		return $selectnode ;
	}

	protected function createAdventureOptionList()
	{
		$selectnode = $this->_canvas->createElement
			( 'select'
			, null
			, array('name' => 'adventure-id')
			) ;

		if(!is_null($this->adventuresList))
		{
			foreach($this->adventuresList as $adv)
			{
				$attrs = array('value' => "{$adv->id}") ;
				if(!is_null($this->newspaper->adventure)
						and $this->newspaper->adventure->id == $adv->id)
					$attrs['selected'] = 'selected' ;

				$optnode = $this->_canvas->createElement
					( 'option'
					, $adv->title
					, $attrs
					) ;

				$selectnode->appendChild($optnode) ;
			}
		}
		
		$attrs = array('value' => 'null') ;
		if(is_null($this->newspaper->adventure))
			$attrs['selected'] = 'selected' ;

		$optnode = $this->_canvas->createElement('option', 'Aucune', $attrs) ;
		$selectnode->appendChild($optnode) ;

		return $selectnode ;
	}
}

class WGContentNewspaperHTMLAdd extends WGContentNewspaperHTMLUpdate
{
	protected function createActionInputNode()
	{
		$hidenode = $this->_canvas->createElement
			( 'input'
			, null
			, array
				( 'name' => 'action'
				, 'value' => 'add'
				, 'type' => 'hidden'
				)
			) ;
		
		return $hidenode ;
	}

	protected function createIdNode()
	{
		$idnode = $this->_canvas->createElement
			( 'input'
			, null
			, array
				( 'name' => 'id'
				, 'type' => 'hidden'
				, 'value' => 'null'
				)
			) ;

		return $idnode ;
	}
}

abstract class WGContentNewspaperList extends Webget
{
	public function setAdventures($advs)
	{
		$this->advs = $advs ;
	}
	
	public function setRange($offset, $count)
	{
		$this->offset = (integer) $offset ;
		$this->count = (integer) $count ;
	}
	
	public function setTotal($total)
	{
		$this->total = (integer) $total ;
	}

	protected $title = null ;
	protected $advs = null ;
	protected $offset = null ;
	protected $count = null ;
	protected $total = null ;
}

class WGContentNewspaperListHTMLShow extends WGContentNewspaperList
{
	public function append()
	{
		trigger_error('TODO') ;
		if($this->isEditable())
		{
			$newnode = $this->_canvas->createElement
				( 'a'
				, 'ajouter'
				, array('href' => 'admin.php?action=add')
				) ;
			$this->_node->appendChild($newnode) ;
		}

		
		// Append adventures list to the node
		if($this->Newspaper instanceof NewspapersCollection)
		{
			$olnode = $this->_canvas->createElement
				( 'ol'
				, null
				, array('style' => "list-style: none ;")
				) ;

			$i = $this->offset ;
			foreach($this->newspaper as $newspaper)
			{
				$i++ ;
				$advtitlenode = $this->_canvas->createElement
					( 'li'
					, "$i. ".$adv->title
					, array('id' => "adv-{$adv->id}")
					) ;

				$gonode = $this->_canvas->createElement
					( 'a'
					, 'voir'
					, array('href' => "adventure.php?id={$adv->id}")
					) ;
				$advtitlenode->appendChild($gonode) ;

				if($this->isEditable())
				{
					$editnode = $this->_canvas->createElement
						( 'a'
						, 'modifier'
						, array
							('href' => "adventure.php?id={$adv->id}&action=edit")
						) ;
					$advtitlenode->appendChild($editnode) ;

					$deletenode = $this->_canvas->createElement
						( 'a'
						, 'supprimer'
						, array
							('href' => "adventure.php?id={$adv->id}&action=del")
						) ;
					$advtitlenode->appendChild($deletenode) ;
				}

				$olnode->appendChild($advtitlenode) ;

				$advcriticnode = $this->_canvas->createElement
					('p', $adv->critic) ;
				$olnode->appendChild($advcriticnode) ;
			}

			$this->_node->appendChild($olnode) ;
		}

		// Append previous context menu
		/*
		if($this->offset > 0)
		{
			$p_offset = $this->offset - $this->count ;
			if($prev_num < 0) $prev_num = 0 ;

			$prev = $this->_canvas->createElement
				( 'a'
				, 'prcdent'
				, array('href' => "{$this->filename}?offset=$p_offset")
				) ;
			$this->_node->appendChild($prev) ;
		}
		*/

		// Append next context menu
		if($this->total > ($this->offset + $this->count))
		{
			$n_offset = $this->offset + $this->count ;

			$next = $this->_canvas->createElement
				( 'a'
				, 'suivant'
				, array('href' => "{$this->filename}?offset=$n_offset")
				) ;
			$this->_node->appendChild($next) ;
		}
	}
}

class WGContentNewspaperListHTMLUpdate extends WGContentNewspaperList
{
	public function append()
	{
		if($this->advs instanceof AdventuresCollection)
		{
			foreach($this->advs as $adv)
			{
				// @todo WG must have own WG chils list
				$advform = new WGContentNewspaperUpdate($this->_canvas) ;
				$advform->setAdventure($adv) ;
				$advform->append() ;
			}
		}
	}
}

?>
